<?php
/**
@brief 
@version $Id$
*/

require_once XOOPS_ROOT_PATH."/modules/exFrame/frameloader.php";

require_once dirname(__FILE__)."/../include/XMLLoader.php";
require_once dirname(__FILE__)."/../class/mapping.php";
require_once dirname(__FILE__)."/../class/trackback.php";

require_once "xoops/perm.php";

/**
@brief $xoopsTpl Υѥå򴹤ƥĤβ˥ȥåХåɽǤ褦ˤ
*/
function b_tbany_hook_execute($options)
{
	global $xoopsTpl;
	global $xoopsUser;

	require_once dirname(__FILE__)."/../include/Smarty_CustomCompiler.php";
	$xoopsTpl->compiler_class="TbAnyTplHookCompiler";
	$arr = b_tbany_block_show($options);

	$xoopsTpl->assign("tbanyhook",$arr);

	return null;
}

function b_tbany_block_show ( $options )
{
	// ѥФ
	$xoops_root_path = strtr(XOOPS_ROOT_PATH,"\\","/");
	$path= $_SERVER['SCRIPT_FILENAME'];
	if(strpos($path,$xoops_root_path)!==FALSE)
		$path=substr($path,strlen($xoops_root_path));

	$loader=new tbanyXMLLoader();
	$loader->path_=$path;
	$loader->load(dirname(__FILE__)."/../include/mapping.xml");

	if(!$loader->pathfind_flag_)	// ɤǤȥåХåϡѥĤʤнʤ
		return;

	$criteria=new CriteriaCompo();
	$criteria->add(new Criteria('path',$path));

	if(count($loader->params_)) {
		foreach($loader->params_ as $param=>$val) {
			if(isset($_REQUEST[$val]))
				$criteria->add(new Criteria($param,intval($_REQUEST[$val])));
			else
				$criteria->add(new Criteria($param,0));
		}
	}

	// ID γƾĴ٤
	$trackbacks=array();

	$handler=new exXoopsObjectHandler(Database::getInstance(),"TbAnyMappingObject");
	$objs=&$handler->getObjects($criteria);
	$obj=is_array($objs) ? $objs[0] : null;
	if(!is_object($obj)) {
		// ʤ鶯¸ID ʤФʤʤ
		$obj=$handler->create();
		$obj->setVar('path',$path);
		foreach($loader->params_ as $param=>$val) {
			if(isset($_REQUEST[$val]))
				$obj->setVar($param,intval($_REQUEST[$val]));
		}
		$handler->insert($obj,true);
	}
	else {	// ʤɤ
		$handler=new exXoopsObjectHandler(Database::getInstance(),"TbAnyTrackbackObject");
		$trackbacks=$handler->getObjects(new Criteria("id",$obj->getVar('id')),null,"receive_date");
	}

	$block['tbany']['nowurl']=$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
	$block['tbany']['mapping']=$obj->getStructure();

	if(is_array($trackbacks))
		foreach($trackbacks as $track)
			$block['tbany']['trackbacks'][]=$track->getStructure();

	$block['tbany']['trackback_count']=count($trackbacks);

	return $block;
}

?>